# I3DExFigurePrimitive Struct Reference
[External Interfaces]

Inheritance diagram for I3DExFigurePrimitive:

List of all members.

## Public Types
enum | EMeshType { kMultiplePolymeshes, kUniquePolymesh }
## Public Member Functions
virtual boolean MCCOMAPI | WeldPolymeshs (IPolymesh *inFirstPolymesh, IPolymesh *inSecondPolymesh)=0
virtual void MCCOMAPI | SetActorInfos (const TMCClassArray< TActorInfo > &inActorInfos)=0
virtual const TMCClassArray < TActorInfo > &MCCOMAPI | GetActorInfos () const =0
virtual void MCCOMAPI | SetMeshMode (EMeshType mode)=0
virtual EMeshType MCCOMAPI | GetMeshMode ()=0
virtual int32 MCCOMAPI | GetActorCount ()=0
virtual int32 MCCOMAPI | AddActor ()=0
| Add an actor and returns its index in the figure primitive.
virtual I3DExFigureActor *MCCOMAPI | GetActor (int32 index)=0
| Gets an actor.
virtual void MCCOMAPI | PostActorWelding ()=0
| Must be called after welding the actor (.
virtual void MCCOMAPI | BeginActorSetCurrentGeometry ()=0
| Can be called before calling multiple SetCurrentGeometry() the actors (.
virtual void MCCOMAPI | EndActorSetCurrentGeometry ()=0
| Can be called after calling multiple SetCurrentGeometry() the actors (.
virtual void MCCOMAPI | ValidateGeometriesCaches ()=0
virtual void MCCOMAPI | FreeGeometriesCaches ()=0
| Free the caches.
virtual boolean MCCOMAPI | IsConforming ()=0
virtual void MCCOMAPI | SetConforming (boolean enable)=0
virtual const TSubdivisionData &MCCOMAPI | GetSubdivisionData ()=0
virtual void MCCOMAPI | SetSubdivisionData (const TSubdivisionData &subdivisionData)=0
virtual I3dExSkinable *MCCOMAPI | GetThisSkinable ()=0
virtual I3DExVertexPrimitive *MCCOMAPI | GetThisVertexPrimitive ()=0
virtual void MCCOMAPI | GetActorsOriginalMeshData (TMCClassArray< TOriginalMeshData > &outData)=0
| Returns data to rebuild the original geometry/topology of the actors.

## Detailed Description

I3DExFigurePrimitive is the interface to functions specific to figure primitives. Figure primitives are a subclass of vertex primitives, and as such always implement the I3DExVertexPrimitive interface as well.

## Member Enumeration Documentation

enum I3DExFigurePrimitive::EMeshType

Enumerator:

  kMultiplePolymeshes |
  kUniquePolymesh |

## Member Function Documentation

virtual int32 MCCOMAPI I3DExFigurePrimitive::AddActor | ( |  | ) | `[pure virtual]`

Add an actor and returns its index in the figure primitive.

virtual void MCCOMAPI I3DExFigurePrimitive::BeginActorSetCurrentGeometry | ( |  | ) | `[pure virtual]`

Can be called before calling multiple SetCurrentGeometry() the actors (.

See also:
  I3DExFigureActor::SetCurrentGeometry())

virtual void MCCOMAPI I3DExFigurePrimitive::EndActorSetCurrentGeometry | ( |  | ) | `[pure virtual]`

Can be called after calling multiple SetCurrentGeometry() the actors (.

See also:
  I3DExFigureActor::SetCurrentGeometry())

virtual void MCCOMAPI I3DExFigurePrimitive::FreeGeometriesCaches | ( |  | ) | `[pure virtual]`

Free the caches.

virtual I3DExFigureActor* MCCOMAPI I3DExFigurePrimitive::GetActor | ( | int32 | index | ) | `[pure virtual]`

Gets an actor.

virtual int32 MCCOMAPI I3DExFigurePrimitive::GetActorCount | ( |  | ) | `[pure virtual]`

virtual const TMCClassArray<TActorInfo>& MCCOMAPI I3DExFigurePrimitive::GetActorInfos | ( |  | ) | const`[pure virtual]`

Parameters:

  | inActorInfos | Actor infos

virtual void MCCOMAPI I3DExFigurePrimitive::GetActorsOriginalMeshData | ( | TMCClassArray< TOriginalMeshData > & | outData | ) | `[pure virtual]`

Returns data to rebuild the original geometry/topology of the actors.

virtual EMeshType MCCOMAPI I3DExFigurePrimitive::GetMeshMode | ( |  | ) | `[pure virtual]`

virtual const TSubdivisionData& MCCOMAPI I3DExFigurePrimitive::GetSubdivisionData | ( |  | ) | `[pure virtual]`

virtual I3dExSkinable* MCCOMAPI I3DExFigurePrimitive::GetThisSkinable | ( |  | ) | `[pure virtual]`

virtual I3DExVertexPrimitive* MCCOMAPI I3DExFigurePrimitive::GetThisVertexPrimitive | ( |  | ) | `[pure virtual]`

virtual boolean MCCOMAPI I3DExFigurePrimitive::IsConforming | ( |  | ) | `[pure virtual]`

virtual void MCCOMAPI I3DExFigurePrimitive::PostActorWelding | ( |  | ) | `[pure virtual]`

Must be called after welding the actor (.

See also:
  I3DExFigureActor::WeldTo)

virtual void MCCOMAPI I3DExFigurePrimitive::SetActorInfos | ( | const TMCClassArray< TActorInfo > & | inActorInfos | ) | `[pure virtual]`

Parameters:

  | inActorInfos | Actor infos

virtual void MCCOMAPI I3DExFigurePrimitive::SetConforming | ( | boolean | enable | ) | `[pure virtual]`

virtual void MCCOMAPI I3DExFigurePrimitive::SetMeshMode | ( | EMeshType | mode | ) | `[pure virtual]`

Parameters:

  | mode | Mesh mode

virtual void MCCOMAPI I3DExFigurePrimitive::SetSubdivisionData | ( | const TSubdivisionData & | subdivisionData | ) | `[pure virtual]`

virtual void MCCOMAPI I3DExFigurePrimitive::ValidateGeometriesCaches | ( |  | ) | `[pure virtual]`

Validates the geometry caches on all actors. It will speed up the calls to I3DExFigureActor::GetGeometryVertices().

virtual boolean MCCOMAPI I3DExFigurePrimitive::WeldPolymeshs | ( | IPolymesh * | inFirstPolymesh,
|  | IPolymesh * | inSecondPolymesh |
| ) |  |  | `[pure virtual]`

Parameters:

  | inPolymesh1 | First group
  | inPolymesh2 | Second group

Returns:
  False if the two polymeshes seem to be oriented differently, True otherwise.

The documentation for this struct was generated from the following file:

- I3DExFigurePrimitive.h